\documentclass[12pt,a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage[tmargin=2cm, bmargin=2cm, lmargin=2cm, rmargin=2cm]{geometry}
\usepackage{indentfirst}
\usepackage{hyperref}
\usepackage{tikz}

\begin{document}
\noindent
\large\textbf{MAC0499 - Supervised Graduate Project}\\
\normalsize Student: Bárbara de Castro Fernandes - NUSP: 7577351\\
Advisor: Prof. Paulo Meirelles\\
Co-advisor: Prof. Fabio Kon

\section*{Monograph proposal}

Linux kernel development: an analysis of the roles, rules, and restrictions of
the community from its trenches.

\section*{Contextualization}

Eric S. Raymond, in his famous 1997 essay \textit{The Cathedral and the
Bazaar}\cite{cathedral}, discusses the open-source software (OSS) development
method, focusing his attention on the Linux kernel community and on his own
experiences managing an OSS project, \textit{fetchmail}. According to his view,
the traditional method of software development should resemble the building of
a cathedral,  ``carefully crafted by individual wizards or small bands of mages
working in splendid isolation, with no beta to be released before its time''.
Linus Torvalds's style of development, on the other hand, resembled more of a
``great babbling bazaar of different agendas and approaches''.

Raymond's essay had a meaningful impact on the software engineering world,
changing the way OSS projects were organized and boosting commercial interest
on them. In the two decades past its publication date, the Linux development
model went through some significant changes, caused mostly by the increased
interest from large companies. Critical transformations happened on the
development process and business model that control how profit can be made
through this kind of software, which led Fitzgerald \cite{fitzgerald} to
suggest the adoption of the term \textit{OSS 2.0} to refer to it. We propose an
examination of this community nowadays, as we believe it has changed
significantly and no longer resemble the bazaar model.

\section*{Proposal}

The goal of this work is to be a subjective analysis of the Linux kernel
community from the inside, through the sending of patches to two of its
subsystems and direct interaction with the community. An analysis of how the
Linux community works nowadays will then be made, and it will then be compared
to how Raymond described it. The Linux project will be analyzed as a whole, as
will its subsystems and the people who are essential for this project to
happen.

Immersion on the development process of the Linux project is expected through
the sending of contributions as a community developer. We will analyze what
metaphor, if not the bazaar, best currently defines the Linux development
model.

The two subsystems to be studied are the Industrial Input/Output and Crypto.
The IIO subsystem aims to provide support to devices that perform
analog-to-digital or digital-to-analog conversions, such as accelerometers,
gyroscopes and temperature sensors. The Crypto subsystem is responsible for all
the cryptographic algorithms and data transformation mechanisms existent in the
kernel.

Interaction with the IIO subsystem is already in the works. Through FLUSP
(FLOSS at USP) I became familiarized with the creation flux and the sending of
patches to the kernel community. FLUSP is an extension group created at the
Institute of Mathematics and Statistics of the University of São Paulo
(IME-USP) in 2018 to stimulate the contribution to Free/Libre Open Source
Software (FLOSS). FLUSP members have already sent contributions to several
large FLOSS projects, such as Linux, GCC, and Git.

\section*{Chronogram}
The development of this work will be divided into the following tasks:

\begin{enumerate}
    \item Exploratory reading: reading of literature revision to
        better understand the problem;
    \item Investigation of the state of practice of Linux development:
	understanding the current state of the field nowadays;
    \item Definition of research questions: development of questions to be made
	    in our evidence-based investigation;
    \item Study of the research methodologies to be applied to the work:
        \begin{itemize}
            \item Case study:
                \begin{itemize}
		    \item Action-research: an examination of problems found in
			the current model and exercising what was learned
			through a practical approach.
                \end{itemize}
        \end{itemize}
    \item Reading of related works: seeking the state-of-the-art of this
    problem as a means to locate this study concerning works of the same theme;
    \item Creation of an action plan:
            \begin{center}
                \begin{tikzpicture}[->,scale=1.8]
                    \node (Action) at (90:1cm)  {Action};
                    \node (Analysis) at (-30:1cm) {Analysis};
                    \node (Reflection) at (210:1cm) {Reflection};

                    \draw (60:1cm)  arc (60:-10:1cm);
                    \draw (-50:1cm) arc (-50:-130:1cm);
                    \draw (190:1cm) arc (190:120:1cm);
                \end{tikzpicture}
            \end{center}
        \begin{itemize}
            \item Introduction to the studied community and its development
                flow: writing about my gathered knowledge regarding the kernel
                community and its subsystems and about how its code and patch
                contributions work;
            \item Writing of a diary of contributions and reflections made:
                writing of blog posts concerning my progress about the
                sending of patches and interaction with the community.
        \end{itemize}
    \item Monograph writing;
    \item Poster confection and slides creation.
\end{enumerate}

The tasks to be done and its respective planned dates are described in
table~\ref{chronogram}.


\begin{table}[h]
	\centering
	\begin{tabular}{|c|c|c|c|c|}
	\hline Tasks & \multicolumn{4}{c|}{Months}  \\
	\hline		 & 4-5 & 6-7 & 8-9 & 10-11      \\
	\hline 1     & x   &     &     &            \\
	\hline 2     & x   &     &     &            \\
	\hline 3     &     & x   &     &            \\
	\hline 4     &     & x   &     &            \\
	\hline 5     &     & x   & x   &            \\
	\hline 6     &     & x   & x   & x          \\
	\hline 7     &     & x   & x   & x          \\
	\hline 8     &     &     &     & x          \\
	\hline
	\end{tabular}
	\caption{Tasks chronogram}
	\label{chronogram}
\end{table}

\section*{Progress}

The exploratory reading has already begun, as well as has the sending of
patches. Four code styling patches have already been sent to the IIO subsystem
and accepted \cite{patch-iio}.

With the reading of Raymond's \cite{cathedral} seminal essay, I understood how
the \textit{cathedral} and \textit{bazaar} models of development were created.
I read Østerlie's \cite{osterlie} paper to become acquainted with the current
state of software engineering research on open-source phenomenon. Finally, a
reading of Fitzgerald \cite{fitzgerald} was essential to understand how OSS
changed through time and no longer resembles the way Raymond described it.

In the next steps, I will continue investigating the state of practice of
Linux development through the sending of patches.

\bibliographystyle{siam}
\bibliography{ref}

\end{document}
